package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZCustom;
import cn.ibizlab.core.sample.filter.IBIZCustomSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZCustomMapper extends BaseMapper<IBIZCustom> {


    Page<IBIZCustom> searchDefault(IPage page, @Param("ctx") IBIZCustomSearchContext context, @Param("ew") Wrapper<IBIZCustom> wrapper);
    List<IBIZCustom> listDefault(@Param("ctx") IBIZCustomSearchContext context, @Param("ew") Wrapper<IBIZCustom> wrapper);

    @Override
    IBIZCustom selectById(Serializable id);

    IBIZCustom selectEntity(IBIZCustom entity);

    List<IBIZCustom> selectEntities(@Param("list") List<IBIZCustom> list);

    @Override
    int insert(IBIZCustom entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZCustom entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZCustom entity, @Param("ew") Wrapper<IBIZCustom> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZCustom> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}